package mirrg.simulation.cart.almandine.mods.vanilla.slots;

import java.util.Optional;

import mirrg.simulation.cart.almandine.GameAlmandine;
import mirrg.simulation.cart.almandine.facroty.property.IDialogProperty;
import mirrg.simulation.cart.almandine.factory.IllegalEntityIdException;
import mirrg.simulation.cart.almandine.mods.vanilla.parts.Bound;
import mirrg.simulation.cart.almandine.mods.vanilla.parts.SlotBase;
import mirrg.simulation.cart.almandine.mods.vanilla.parts.StationBase;
import mirrg.simulation.cart.almandine.mods.vanilla.stackslab.SlotSlab;

public class SlotCart extends SlotBase
{

	@Deprecated
	public SlotCart()
	{
		super();
	}

	public int idStation;

	public SlotCart(GameAlmandine game, Bound bound, int idStation)
	{
		super(game, bound);
		this.idStation = idStation;
	}

	@Override
	public Optional<SlotSlab> getSlotSlab() throws IllegalEntityIdException
	{
		return game.factory.getEntityOrThrow(idStation, StationBase.class).getCarts()
			.findFirst()
			.map(cart -> cart.slot);
	}

	@Override
	protected void addProperty(IDialogProperty dialogProperty)
	{
		super.addProperty(dialogProperty);

		dialogProperty.addPropertyInt("IdStation", "id", () -> idStation, idStation -> {

			// 駅が存在しないIDは棄却
			if (!game.factory.getEntity(idStation, StationBase.class).isPresent()) return false;

			this.idStation = idStation;
			return true;
		});
	}

}
