package mirrg.simulation.cart.almandine.mods.vanilla.stations;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import mirrg.simulation.cart.almandine.factory.Factory;
import mirrg.simulation.cart.almandine.mods.vanilla.parts.StationBase;
import mirrg.swing.helium.logging.HLog;

public class AIStation
{

	public static AIStation compile(String script)
	{
		ScriptEngineManager manager = new ScriptEngineManager();
		ScriptEngine engine = manager.getEngineByName("js");

		try {
			engine.eval(script);
		} catch (ScriptException e) {
			return new AIStation(false);
		}

		return new AIStation(engine);
	}

	public boolean compileOk = true;
	public ScriptEngine engine;

	public AIStation(boolean compileOk)
	{
		this.compileOk = compileOk;
	}

	public AIStation(ScriptEngine engine)
	{
		this.engine = engine;
	}

	public void run(Factory factory, StationBase station)
	{
		Invocable invocable = (Invocable) engine;

		try {
			invocable.invokeFunction("route", factory, station);
		} catch (NoSuchMethodException e) {
			//HLog.processExceptionWarning(e);
		} catch (NullPointerException e) {
			HLog.processExceptionWarning(e);
		} catch (ScriptException e) {
			HLog.processExceptionWarning(e);
		}
	}

}
