package mirrg.util;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class HString
{

	private final static Pattern extension = Pattern.compile("\\.(?=[^\\.]*\\Z)");

	public static String getIndexedFilePath(String filePath, int index)
	{
		if (index == 0) return filePath;

		String prefix;
		String suffix;
		{
			Matcher m = extension.matcher(filePath);
			if (m.find()) {
				prefix = filePath.substring(0, m.start());
				suffix = m.group() + filePath.substring(m.end());
			} else {
				prefix = filePath;
				suffix = "";
			}
		}

		return prefix + "_" + index + suffix;
	}

	public static String toString(double value)
	{
		StringBuffer sb = new StringBuffer(String.format("%.18f", value));

		while (sb.charAt(sb.length() - 1) == '0') {
			sb.setLength(sb.length() - 1);
		}

		if (sb.charAt(sb.length() - 1) == '.') {
			sb.setLength(sb.length() - 1);
		}

		return sb.toString();
	}

	private static final Pattern patternFileNameExtension =
		Pattern.compile("\\.([^\\.\\\\]+)\\Z");

	public static String deleteExtension(String filename)
	{
		Matcher matcher = patternFileNameExtension.matcher(filename);
		if (matcher.find()) {
			return filename.substring(0, matcher.start());
		} else {
			return filename;
		}
	}

}
